(*
   PROJECT          : StatPascal example program
   FILE-SPEC.       : pickands.sp
   AUTHOR           : R.-D. Reiss, M. Thomas
   CREATION DATE    : Nov-3-1994
   LAST UPDATE      : Dec-18-2000
   VERSION          : 1.0
   FUNCTIONAL DESCR.: Implementation of Pickands (GP) estimator
   REQUIRES	    : Active univariate data set
   OUTPUT	    : POT estimator dialog box
   SPECIAL FEATURES : None
*)

estimator Pickands GP;
returning gamma;

function EstimateGamma (m: integer): real;
    var h1, h2: real;
    begin
	if m < 1 then return 1.0;
	h1 := data (samplesize - m + 1) 
		- data (samplesize - 2*m + 1);
	h2 := data (samplesize - 2*m + 1) 
		- data (samplesize - 4*m + 1);
	return log (h1 / h2) / log (2)
    end;

begin
    gamma := EstimateGamma (extremes div 4)
end.
